/* Ellipse_12.pde

Written by: Marvin C. Jones and Richard (Rick) G. Freedman

Because arrays can store lists of anything that can be a variable, you can also 
make arrays for your own classes.  We use our blueprint for animating a circle 
so that we can make multiple circles by creating an array with one entry per
circle in this program.  Compare this to the two variables used in Ellipse_11.pde.
This also allows us to introduce loops that can repeat lines of code.
*/

//We declare the variables we will use in the program at the beginning
//The variable named arrayCircle sorts a list (called an array[]) of objects 
//  created by the class named myClass
myClass[] arrayCircle;

void setup()
{
  //Set the window's size to 500 pixels wide and 300 pixels tall
  size(500, 300);
  //Perform draw() five times per second
  frameRate(5);

  //The equals sign (=) tells the program to store a value in a variable
  //  The array needs to know how many objects are in its list - let's use 2
  arrayCircle = new myClass[2];

  //Now we can store an object at each item in the array
  //  Notice that the brackets are now on the side with the name of the array
  //  The code in myClass explains how to create these objects
  //NOTE: We begin counting the items in an array at 0 instead of 1
  //NOTE: We use the command 'new' in front of the right-hand side like an array 
  //      (this is because arrays are also objects in Processing)
  arrayCircle[0] = new myClass(100, 100, 50);
  arrayCircle[1] = new myClass(30, 50, 70);
}

void draw()
{
  //This will erase everything currently drawn in the pop-up window
  clear();

  //Use the color purple when drawing shapes on the screen
  fill(125,0,125);

  /*This is a for loop - it has several parts:
    int i = 0; //This is a temporary variable that we will use in the loop, and 
               //  we assign it the value of 0 at the start
    i < 2;     //This is the condition for which the loop will repeat; since i 
               //  begins at 0, which is < 2, we will perform the loop at least once
    i++        //This is a single step performed at the end of the block of code,
               //  and it should help us break the condition to stop repeating
               //NOTE: i++ is the same as i = i + 1
    //We start at i = 0, which is < 2, then i++ gives us i=1, which is also < 2, and 
    //  then i++ again gives us i=2, which is not < 2 so that we stop looping and 
    //  the code in the block is only run two times (when i = 0 and when i = 1)
  */
  for(int i = 0; i < 2; i++)
  {
    //This command tells the object stored in the i-th entry of the array to 
    //  perform its drawMyself() function that we created for it (see myClass.pde)
    arrayCircle[i].drawMyself();
  }
}
